/* src/opdeop.c - Fonctions de base chanserv (op, deop, voice, devoice, etc)
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: opdeop.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

void op(aNick *nick, int parc, char **parv)
{
  int i, count = 0;
  char buff[100], mode[7], *c;
  struct nickinfo *n;
  struct joininfo *chan;
  buff[0] = '\0';
  mode[0] = '\0';
  c = parv[1];

  if(parc == 1)
  {
	  for(chan=nick->joinhead;chan && strcasecmp(chan->channel, c);chan=chan->next);
	  if(!chan)
	  {
		  uwntc(nick->numeric, "Vous n'tes pas sur %s", c);
		  return;
	  }
	  chan->is_op = 1;
	  uwmode(c, "+o %s", nick->numeric);
	  return;
  }
  for(i=2;i<=parc;i++)
  {
	  if(!strcasecmp(parv[i], uw.nick)) continue;
	  if(!(n = getnickbynick(parv[i])))
	  {
		  uwntc(nick->numeric, NOTCONNECTED, parv[i]);
		  continue;
	  }
	  for(chan=n->joinhead;chan && strcasecmp(chan->channel, c);chan=chan->next);
	  if(!chan)
	  {
		  uwntc(nick->numeric, "%s n'est pas sur %s", n->nick, c);
		  continue;
	  }
	  if(chan->is_op) continue;
	  chan->is_op = 1;

	  count++;
	  strcat(mode, "o");
	  sprintf(buff, "%s %s", buff, n->numeric);
	  if(strcasecmp(n->numeric, nick->numeric)) uwntc(n->numeric, "Vous avez t Op sur %s par %s", c, nick->user->nick);
	  if(count > 5)
	  {
		  uwmode(c, "+%s %s", mode, buff);
		  count = 0;
		  buff[0] = '\0';
		  mode[0] = '\0';
	  }
  }

  if(count) uwmode(c, "+%s %s", mode, buff);
  return;
}

void deop(aNick *nick, int parc, char **parv)
{
  int i, count = 0;
  char buff[100], mode[7], *c;
  struct nickinfo *n;
  struct joininfo *chan;

  buff[0] = '\0';
  mode[0] = '\0';
  c = parv[1];

  if(parc == 1)
  {
	  for(chan=nick->joinhead;chan && strcasecmp(chan->channel, c);chan=chan->next);
	  if(!chan)
	  {
		  uwntc(nick->numeric, "Vous n'tes pas sur %s", c);
		  return;
	  }
	  chan->is_op = 0;
	  uwmode(c, "-o %s", nick->numeric);
	  return;
  }
  for(i=2;i<=parc;i++)
  {
	  if(!strcasecmp(parv[i], uw.nick))
	  {
		  uwntc(nick->numeric, "Merci de ne pas Deop %s", uw.nick);
		  continue;
	  }

	  if(!(n = getnickbynick(parv[i])))
	  {
		  uwntc(nick->numeric, NOTCONNECTED, parv[i]);
		  continue;
	  }
	  if(n->is_oper)
	  {
		  uwntc(nick->numeric, "%s est IRCop.", n->nick);
		  continue;
	  }
	  if(n->user && n->user->level > 1 && n->user->level > nick->user->level)
	  {
		  uwntc(nick->numeric, "%s est Administrateur des Services.", n->nick);
		  continue;
	  }

	  for(chan=n->joinhead;chan && strcasecmp(chan->channel, c);chan=chan->next);
	  if(!chan)
	  {
		  uwntc(nick->numeric, "%s n'est pas sur %s", n->nick, c);
		  continue;
	  }
	  chan->is_op = 0;
	  count++;
	  strcat(mode, "o");
	  sprintf(buff, "%s %s", buff, n->numeric);
	  if(strcasecmp(n->numeric, nick->numeric)) uwntc(n->numeric, "Vous avez t DeOp sur %s par %s", c, nick->user->nick);
	  if(count > 5)
	  {
		  uwmode(c, "-%s %s", mode, buff);
		  count = 0;
		  buff[0] = '\0';
		  mode[0] = '\0';
	  }
  }
  if(count) uwmode(c, "-%s %s", mode, buff);
  return;
}

void opall(aNick *nick, int parc, char **parv)
{
	struct nickinfo *n;
	struct joininfo *chan;
	char *c, buf[150], m[7];
	int i = 0;
	c = parv[1];
	buf[0] = '\0';
	m[0] = '\0';

	n = nickhead;
	while(n != NULL)
	{
		chan = n->joinhead;
		while(chan != NULL)
		{
			if(!strcasecmp(chan->channel, c) && !chan->is_op)
			{
				strcat(m, "o");
				sprintf(buf, "%s %s", buf, n->numeric);
				chan->is_op = 1;
				i++;
				if(i > 5)
				{
					uwmode(c, "+%s %s", m, buf);
					i = 0;
					buf[0] = '\0';
					m[0] = '\0';
				}
				break;
			}
			chan = chan->next;
		}
		n = n->next;
	}
	if(i > 0 && buf[0] != '\0') uwmode(c, "+%s %s", m, buf);
	return;
}

void deopall(aNick *nick, int parc, char **parv)
{
	struct nickinfo *n;
	struct joininfo *chan;
	char *c, buf[150], m[7];
	int i = 0;
	c = parv[1];
	buf[0] = '\0';
	m[0] = '\0';

	n = nickhead;
	while(n != NULL)
	{
		if(!strcasecmp(n->nick, nick->nick) || (!n->is_oper && (n->user == NULL || n->user->level <= 1 || n->user->level <= nick->user->level)))
		{
			chan = n->joinhead;
			while(chan != NULL)
			{
				if(!strcasecmp(chan->channel, c) && chan->is_op)
				{
					strcat(m, "o");
					sprintf(buf, "%s %s", buf, n->numeric);
					chan->is_op = 0;
					i++;
					if(i > 5)
					{
						uwmode(c, "-%s %s", m, buf);
						i = 0;
						buf[0] = '\0';
						m[0] = '\0';
					}
					break;
				}
				chan = chan->next;
			}
		}
		n = n->next;
	}
	if(i) uwmode(c, "-%s %s", m, buf);
	return;
}

void voice(aNick *nick, int parc, char **parv)
{
  int i, count = 0;
  char buff[100], mode[7], *c;
  struct nickinfo *n;
  struct joininfo *chan;
  buff[0] = '\0';
  mode[0] = '\0';
  c = parv[1];

  if(parc == 1)
  {
	  for(chan=nick->joinhead;chan && strcasecmp(chan->channel, c);chan=chan->next);
	  if(!chan)
	  {
		  uwntc(nick->numeric, "Vous n'tes pas sur %s", c);
		  return;
	  }
	  uwmode(c, "+v %s", nick->numeric);
	  chan->is_voice = 1;
	  return;
  }
  for(i=2;i<=parc;i++)
  {
	  if(!strcasecmp(parv[i], uw.nick)) continue;
	  n = getnickbynick(parv[i]);
	  if(!n)
	  {
		  uwntc(nick->numeric, NOTCONNECTED, parv[i]);
		  continue;
	  }
	  for(chan=n->joinhead;chan && strcasecmp(chan->channel, c);chan=chan->next);
	  if(!chan)
	  {
		  uwntc(nick->numeric, "%s n'est pas sur %s", n->nick, c);
		  continue;
	  }
	  if(chan->is_voice) continue;
	  chan->is_voice = 1;

	  count++;
	  strcat(mode, "v");
	  sprintf(buff, "%s %s", buff, n->numeric);
	  if(strcasecmp(n->numeric, nick->numeric)) uwntc(n->numeric, "Vous avez t Voic sur %s par %s", c, nick->user->nick);
	  if(count > 5)
	  {
		  uwmode(c, "+%s %s", mode, buff);
		  count = 0;
		  buff[0] = '\0';
		  mode[0] = '\0';
	  }
  }

  if(count) uwmode(c, "+%s %s", mode, buff);
  return;
}

void devoice(aNick *nick, int parc, char **parv)
{
  int i, count = 0;
  char buff[100], mode[7], *c;
  struct nickinfo *n;
  struct joininfo *chan;

  buff[0] = '\0';
  mode[0] = '\0';
  c = parv[1];

  if(parc == 1)
  {
	  for(chan=nick->joinhead;chan && strcasecmp(chan->channel, c);chan=chan->next);
	  if(!chan)
	  {
		  uwntc(nick->numeric, "Vous n'tes pas sur %s", c);
		  return;
	  }
	  uwmode(c, "-v %s", nick->numeric);
	  chan->is_voice = 0;
	  return;
  }
  for(i=2;i<=parc;i++)
  {
	  n = getnickbynick(parv[i]);
	  if(!n)
	  {
		  uwntc(nick->numeric, NOTCONNECTED, parv[i]);
		  continue;
	  }

	  for(chan=n->joinhead;chan && strcasecmp(chan->channel, c);chan=chan->next);
	  if(!chan)
	  {
		  uwntc(nick->numeric, "%s n'est pas sur %s", n->nick, c);
		  continue;
	  }
	  if(!chan->is_voice) continue;
	  chan->is_voice = 0;
	  count++;
	  strcat(mode, "v");
	  sprintf(buff, "%s %s", buff, n->numeric);
	  if(strcasecmp(n->numeric, nick->numeric)) uwntc(n->numeric, "Vous avez t DeVoic sur %s par %s", c, nick->user->nick);
	  if(count > 5)
	  {
		  uwmode(c, "-%s %s", mode, buff);
		  count = 0;
		  buff[0] = '\0';
		  mode[0] = '\0';
	  }
  }
  if(count) uwmode(c, "-%s %s", mode, buff);
  return;
}

void voiceall(aNick *nick, int parc, char **parv)
{
	struct nickinfo *n;
	struct joininfo *chan;
	char *c, buf[150], m[7];
	int i = 0;
	c = parv[1];
	buf[0] = '\0';
	m[0] = '\0';

	n = nickhead;
	while(n != NULL)
	{
		chan = n->joinhead;
		while(chan != NULL)
		{
			if(!strcasecmp(chan->channel, c) && !chan->is_voice)
			{
				strcat(m, "v");
				sprintf(buf, "%s %s", buf, n->numeric);
				chan->is_voice = 1;
				i++;
				if(i > 5)
				{
					uwmode(c, "+%s %s", m, buf);
					i = 0;
					buf[0] = '\0';
					m[0] = '\0';
				}
				break;
			}
			chan = chan->next;
		}
		n = n->next;
	}
	if(i > 0 && buf[0] != '\0') uwmode(c, "+%s %s", m, buf);
	return;
}

void devoiceall(aNick *nick, int parc, char **parv)
{
	struct nickinfo *n;
	struct joininfo *chan;
	char *c, buf[150], m[7];
	int i = 0;
	c = parv[1];
	buf[0] = '\0';
	m[0] = '\0';

	n = nickhead;
	while(n != NULL)
	{
		chan = n->joinhead;
		while(chan != NULL)
		{
			if(!strcasecmp(chan->channel, c) && chan->is_voice)
			{
				strcat(m, "v");
				sprintf(buf, "%s %s", buf, n->numeric);
				chan->is_voice = 0;
				i++;
				if(i > 5)
				{
					uwmode(c, "-%s %s", m, buf);
					i = 0;
					buf[0] = '\0';
					m[0] = '\0';
				}
				break;
			}
			chan = chan->next;
		}
		n = n->next;
	}
	if(i && buf[0] != '\0') uwmode(c, "-%s %s", m, buf);
	return;
}

void kickall(aNick *nick, int parc, char **parv)
{
	struct nickinfo *n;
	struct joininfo *chan;
	char *c, r[180];
	c = parv[1];

	if(parc < 2) strncpy(r, "Requested", 9);
	else strncpy(r, parv2msg(parc,parv,2), 180);

	n = nickhead;
	while(n)
	{
		if(!n->is_oper && (!nick || strcasecmp(n->nick,nick->nick)) && (!n->user || (n->user && n->user->level < 2)))
		{
			chan = n->joinhead;
			while(chan)
			{
				if(!strcasecmp(chan->channel, c))
				{
					del_join(n->nick, chan->channel);
					uwkick(c, n->numeric, "%s", r);
					break;
				}
				chan = chan->next;
			}
		}
		n = n->next;
	}
	return;
}

void kickbanall(aNick *nick, int parc, char **parv)
{
	struct nickinfo *n;
	struct joininfo *chan;
	char *c, r[180], m[HOSTLEN], mask[HOSTLEN + USERLEN + 3];
	int a,b,d,e;
	c = parv[1];

	if(parc < 2)
	{
		uwntc(nick->numeric, "Veuillez prciser une raison.");
		return;
	}
	strncpy(r, parv2msg(parc,parv,2), 180);

	n = nickhead;
	while(n)
	{
		if(!n->is_oper && strcasecmp(n->nick,nick->nick) && (!n->user || (n->user && n->user->level < 2)))
		{
			chan = n->joinhead;
			while(chan)
			{
				if(!strcasecmp(chan->channel, c))
				{
					if(is_ip(n->host))/*on formate le ban*/
					{
						sscanf(n->host, "%d.%d.%d.%d", &a,&b,&d,&e);
						snprintf(m, 200, "%d.%d.%d.*",a,b,d);
					}
					else snprintf(m, HOSTLEN, "*%s", strchr(n->host, '.'));
					snprintf(mask, (HOSTLEN + USERLEN + 3), "*!*%s@%s", n->ident, m);

					del_join(n->nick, c);
					uwmode(c, "+b %s", mask);
					uwkick(c, n->numeric, "%s", r);
					break;
				}
				chan = chan->next;
			}
		}
		n = n->next;
	}
	return;
}
