/* src/showcommands.c - Liste les commandes
 * Copyright (C) 2002 Inter System (Progs@Inter-System.Net)
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: showcommands.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

void showcommands(aNick *nick, int parc, char **parv)
{
	char cmds[150];
	int level, premier, j, maxlevel=0;

	if(nick->user)
		maxlevel = nick->user->level;
	else maxlevel = 0;

	for(level = 0; level<=500; level++)
	{
		if(!level || (level >= 5 && level <= maxlevel) || (nick->user && level < 5 && nick->user->level >= level))
		{
			premier = 1;
			cmds[0]='\0';
			for(j = 0;uw_cmds[j].cmd[0] != '\0';j++)
			{
				if(uw_cmds[j].level == level && uw_cmds[j].cmd[0] != CTCP_DELIM_CHAR && !uw_cmds[j].disable)
				{
					strcat(cmds, " ");
					strcat(cmds, uw_cmds[j].cmd);
					if(strlen(cmds) > 80)
					{
						if(premier)
						{
							premier=0;
							if(level == 1)
								uwntc(nick->numeric, "------------------[ \0036Commandes \002\0034Admins\003\002 ]------------------");
							else if(!level)
								uwntc(nick->numeric, "------------------[ \0036Commandes \002\0033Users\003\002  ]------------------");
							uwntc(nick->numeric, "\002Niveau %3d:\002%s", level, cmds);
							cmds[0]='\0';
						}
						else
						{
							uwntc(nick->numeric, "          \002:\002%s", cmds);
							cmds[0]='\0';
						}
					}
				}
			}
			if(cmds[0] != '\0')
			{
				if(premier)
				{
					if(level == 1)
						uwntc(nick->numeric, "------------------[ \0036Commandes \002\0034Admins\003\002 ]------------------");
					else if(!level)
						uwntc(nick->numeric, "------------------[ \0036Commandes \002\0033Users\003\002  ]------------------");
					uwntc(nick->numeric, "\002Niveau %3d:\002%s", level, cmds);
					cmds[0]='\0';
				}
				else
				{
					uwntc(nick->numeric, "          \002:\002%s", cmds);
					cmds[0]='\0';
				}
			}
		}
	}
	uwntc(nick->numeric, "Pour de l'aide sur une commande tapez \037/msg %s AIDE <commande>\037", parv[0]);
	uwntc(nick->numeric, "Vous pouvez demander plus d'informations sur \002%s", bot.chan);
	return;
}
