/* src/flood.c - protection contre le flood
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define FLOODTIME 5
#define FLOODLINES 3
#define FLOODMESSAGE "Veuillez ne pas flooder Z ! Vous tes maintenant ignor..."
#include <main.h>
#include <time.h>

CVSINFO("$Id: flood.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

//Renvoie 1 si un flood est detect
int checkflood(aNick *nick)
{
   long gettime = time(NULL);
   /*char m[300], mask[200];
   int a,b,c,d;*/

   if(adminexempt && nick->user && nick->user->level > 1) return 0;

   if(nick->floodtime + FLOODTIME < gettime) //le privmsg precedent date de trop longtemps
   {
      nick->floodtime = gettime; //on met a jour la variable du dernier privmsg
	  nick->floodcount = 1; //on remet a 1 le nombre de lignes
	  del_ignore(nick->host);
	  return 0;
   }
   else //le privmsg est assez recent pour etre control
   {
      if(nick->floodcount >= FLOODLINES) //flood detect !
	  {
		  /*if(is_ip(nick->host))
		  {
			  sscanf(nick->host, "%d.%d.%d.%d", &a,&b,&c,&d);
			  snprintf(m, 300, "%d.%d.%d.*",a,b,c);
		  }
		  else snprintf(m, 300, "*%s", strchr(nick->host, '.'));
		  snprintf(mask, 300,"*!*%s@%s", nick->ident, m);*/
		  add_ignore(nick->host,(ignoretime + gettime));

		  if(killforflood) putserv(":%s KILL %s :%s\n", uw.nick, nick->numeric, FLOODMESSAGE);
		  else uwntc(nick->numeric, FLOODMESSAGE);
		 return 1;
	  }
	  else
	  {
	     nick->floodcount++;
		 return 0;
	  }
   }
}

int isignore(aNick *nick)
{
	struct ignore *i;
	/*char h[500];
	snprintf(h, 500, "%s!%s@%s",nick->nick,nick->ident,nick->host);*/
	for(i=ignorehead;i;i=i->next)
	{
		if(!strcasecmp(i->host,nick->host)) {
			if(i->exp <= time(NULL))
			{
				del_ignore(i->host);
				return 0;
			}
			else return 1;
		}
	}
	return 0;
}

void check_ignores()
{
	struct ignore *i,*i2;
	long p = time(NULL);

	for(i=ignorehead;i;i=i2)
	{
		i2=i->next;
		if(p >= i->exp) del_ignore(i->host);
	}
	return;
}
